/*--------------------------------------------------------------------.
| qless.c							      |
| 								      |
| Copyright (c) 1997 Jonathan Hudson				      |
| 								      |
| You may distribute under the terms of either the GNU General Public |
| License or the Artistic License, as specified in the README file.   |
`--------------------------------------------------------------------*/
static char rcsid[] = "$Id$";
/*
 * $Log$: 
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <qdos.h>
#include <time.h>
#include <things.h>
#include <qptr.h>

void (*_SigStart)(void) = NULL;

typedef struct mitem
{
    short len;
    char chrs[1];
} MITEM;

typedef struct
{
    void *next;
    void *item;
} LLIST;

typedef struct
{
    struct QD_text *qtext;
    unsigned char status;
} MDEF;

char _prog_name[] = "qless";

typedef struct WM_menw WM_menw_t;

static long MACT (WM_wwork_t *wwk, WM_menw_t *mw, char *mst, 
		  short col, short row);
static long MDRAW (WM_wwork_t *wwk, struct WM_menw *mw);

static struct WM_action mdraw = {JSR, wm_drwaw, MDRAW};
static struct WM_action mact = {JSR, wm_actme, MACT};

#define MAX_SECT    1

static WM_PWCB (2) pwcy = {0};
static QD_TEXTI (PROMPT, "         ");
static long MESC (WM_wwork_t *wwk, struct WM_litm *li);
static struct WM_action mesc = {JSR, wm_actli, MESC};
static QD_TEXTI (ESCAPE, "Quit");

static long MMOVE (WM_wwork_t *wwk, struct WM_litm *li);

static struct WM_action mmove = {JSR, wm_actli, MMOVE};

static long lit_event (struct WM_wwork *wwk, struct WM_litm *li)
{
    return li->skey + 14;	/* calculate event for selection key */
}

static struct WM_action msize = {JSR, wm_actli, lit_event};

static struct WM_info info[] =	/* information objects */
{
    {60, 10,			/* xsize, ysize         size */
     0, 0,			/* xorg, yorg           and origin */
     TYP_TEXT, 0,		/* type, spare          item type */
     {0, 0, 0}, 		/* ink, cwid, chgt      character attributes */
     &PROMPT},			/* *pobj                pointer to object */
    {-1}
};

static struct WM_infw infw[] =
{
 /*  xs  ys  xo   yo   flag     bw bc papr  pobj */
    { 0, 14,  0,   0,    0,     0, 0, 127,  NULL},
    {66, 10,  0,   2,    0,     1, 255, 7,  info},
    {24, 10,  0,   2,    0,     1, 255, 7,  NULL},
    {22, 10,  4,   2,    0,     1, 255, 7,  NULL},
    {22, 10, 28,   2,    0,     1, 255, 7,  NULL},
    {-1}
};

static struct WM_menw mw =	/* menu window */
{
    0, 0,		/* xsize, ysize         size */
    2, 14,		/* xorg, yorg           and origin */
    0,  		/* flag                 no clear + shadow */
    1, 0, 7,		/* borw, borc, papr     border width/clr, paper */
    NULL,		/* *pspr                pointer to sprite */
    &mdraw,		/* *draw                draw routine */
    wm__mhit,		/* *hit                 hit routine */
    wm__pnsc,		/* *ctrl                control routine */
    0, MAX_SECT,	/* nxsc, nysc           max x,y sections */
    0, 0, 0,		/* skey, 2 spare        selection keystroke */
    NULL,		/* *pwcb            part window ctrl block */
    0, 0, 0, 0, 0, 0, NULL, NULL,	/* 6 short 2 pointer zero */
    2, 7, 0,	  /* psac, psbc, pssc arrow/bar clrs */
    (WM_pwcb_t *) &pwcy,	/* *pwcb            part window ctrl block */
    0, 0, 0, 0, 0, 0, NULL, NULL,	/* 6 short 2 pointer zero */
    2, 7, 0,          	/* psac, psbc, pssc arrow/bar clrs */
    NULL,		/* *mstt                menu status area */
    1, 0,		/* curw, curc           current item width/clr */
    7, 0, NULL, NULL,	/* uback, uink, *ublob, *upatt unavail */
    7, 0, NULL, NULL,	/* aback, aink, *ablob, *apatt  avail */
    0, 7, NULL, NULL,	/* sback, sink, *sblob, *spatt selected */
    1, 0,			/* ncol, nrow           columns and rows */
    0, 0,			/* xoff, yoff           window offset */
    {0, 0},			/* -xsize, -xspce     or *xspc spacing list */
    {-10, -12},			/* -ysize, -yspce     or *yspc spacing list */
    NULL, NULL,			/* *xind, *yind         not implemented */
    NULL			/* *rowl                row list */
};

static struct WM_litm plitm[] =	/* loose item */
{
 /*  xs  ys    xo  yo  xj  yj   type      key      pobj     item  pact */
    {24, 10,    0,  2,  0,  0, TYP_TEXT,   3,    &ESCAPE,    0,  &mesc},
    {22, 10,    4,  2,  0,  0,   2,     K_MOVE,  &mes_move,  1,  &mmove},
    {22, 10,   28,  2,  0,  0,   2,     K_SIZE,  &mes_size,  2,  &msize},
    {-1}
};

struct WM_appl appl[] = {(WM_appw_t *) &mw, NULL};

#define ninfw   ((sizeof(infw)/sizeof(WM_infw_t))-1)
#define ninfo   ((sizeof(info)/sizeof(WM_info_t))-1)
#define nlitm   ((sizeof(plitm)/sizeof(WM_litm_t))-1)
#define nappl   1

static WM_WSCALE (ninfw + ninfo + nlitm + nappl) wsc =
{
    200, 100, 0, 0, 6, 12,
    {
	{8, 0, 0, 0},		/* infw[0], x scale */
	{0, 0, 4, 0},		/* infw[1], centre */
	{0, 0, 0, 0},		/* info[0], no scale */
	{0, 0, 8, 0},		/* infw[2], right */
	{0, 0, 0, 0},		/* infw[3], no scale */
	{0, 0, 0, 0},		/* infw[4], no scale */
	{0, 0, 8, 0},		/* litm[0], right jst */
	{0, 0, 0, 0},		/* litm[1], no scale */
	{0, 0, 0, 0},		/* litm[2], no scale */
	{8, 8, 0, 0}	        /* appl[0], full scale */
    }
};


static WM_wwork_t ww =	/* window working definition */
{
    NULL,	/* *wstat;              pointer to status area */
    (WM_wscale_t *) &wsc,	/* *wscale this was pointer to WDEF */
    0,		/* chid                 channel ID */
    NULL,	/* *pprec               pointer to pointer record */
    0,		/* psave                pointer position saved */
    0, 0, 0, 0,	/* 4 zero */
    appl,	/* *splst               pointer to sprite list */
    0, 0,	/* xsize, ysize will need changing */
    4, 23,	/* xorg, yorg           and origin */
    2 | NO_WCLEAR,	/* flag                 no clear + shadow */
    1, 0, 255,    	/* borw, borc, papr     border width/clr, paper */
    NULL,		/* *sprite              pointer to sprite */
    1, 0,		/* curw, curc           current item width/clr */
    7, 0, NULL, NULL,	/* uback, uink, *ublob, *upatt  unavail */
    7, 0, NULL, NULL,	/* aback, aink, *ablob, *apatt  avail */
    7, 0, NULL, NULL,	/* sback, sink, *sblob, *spatt  selected */
    NULL,			/* *help */
    ninfw, ninfo, infw,		/* ninfo, ninob, *pinfo info winds */
    nlitm, plitm,		/* nlitm, *plitm        loose items */
    nappl, appl			/* nappl  *pappl        appl winds */
};
    
static struct WM_wstat ws = {0};

#define MAXX 480
#define MAXY 240

static void scale (struct WM_swdef *sw, char sc[], short dx, short dy)
{

    if (sc[0])
	sw->xsize += (dx * sc[0]) >> 3;
    if (sc[1])
	sw->ysize += (dy * sc[1]) >> 3;
    if (sc[2])
	sw->xorg += (dx * sc[2]) >> 3;
    if (sc[3])
	sw->yorg += (dy * sc[3]) >> 3;
}

static void GetLimits (struct WM_wwork *wwk)
{
    short nln;
    struct WM_wsiz wl;

    iop_flim (wwk->chid, -1, &wl);
    wwk->wscale->xmax = ((wl.xsize - 18) / 6) * 6;
    wwk->wscale->ymax = 16 + 12*((wl.ysize - 24)/12);
}

short re_scale (struct WM_wwork *wwk, short *pdx, short *pdy)
{
    short newsx;
    short newsy;
    int iscale;
    short res = 0;
    struct WM_wscale *sc;
    struct WM_infw *infw;
    struct WM_info *info;
    struct WM_litm *litm;
    struct WM_appl *appl;
    struct WM_appw *appw;

    sc = wwk->wscale;

    newsx = wwk->xsize + ((*pdx + sc->xinc / 2) / sc->xinc) * sc->xinc;

    if (newsx > sc->xmax)
	newsx = sc->xmax;
    else if (newsx < sc->xmin)
	newsx = sc->xmin;

    *pdx = newsx - wwk->xsize; 

    newsy = wwk->ysize + ((*pdy + sc->yinc / 2) / sc->yinc) * sc->yinc;

    if (newsy > sc->ymax)
	newsy = sc->ymax; 
    else if (newsy < sc->ymin)
	newsy = sc->ymin;
    *pdy = newsy - wwk->ysize;

    if (*pdx || *pdy)
    {
	res = 1;
        wwk->xsize = newsx;		/* set size */
        wwk->ysize = newsy;		/* set size */

	iscale = 0;
	if (infw = wwk->pinfo)
	    while (infw->xsize >= 0)
	    {
		scale ((WM_swdef_t *) infw, sc->s8[iscale++], *pdx, *pdy);

		if (info = (infw++)->pobl)
		    while (info->xsize >= 0)
		    {
			scale ((WM_swdef_t *) info, sc->s8[iscale++], *pdx, 
			       *pdy);
                        info++;
		    }
	    }

	if (litm = wwk->plitm)
	    while (litm->xsize >= 0)
	    {
		scale ((WM_swdef_t *) litm, sc->s8[iscale++], *pdx, *pdy);
                litm++;
	    }
	if (appl = wwk->pappl)
	    while (appw = (appl++)->pappw)
		scale ((WM_swdef_t *) appw, sc->s8[iscale++], *pdx, *pdy);
    }
    return res;
}



long resize (struct WM_wwork *wwk, short lit_size)
{
    static short flag = 0, ix, iy;
    short dx, dy, last;
    int sts;
    short res = 0;

    wwk->wstat->litem[lit_size] = WSI_MKAV;
    GetLimits (wwk);

    sts = wm_chwin (wwk, &dx, &dy);
    dx = -dx;
    dy = -dy;		/* our true sense of change size */

    res = re_scale (wwk, &dx, &dy);
    if(res)
    {
	wm_unset (wwk);	
	wwk->xorg = wwk->wstat->ptpsx - wwk->xorg;
	wwk->yorg = wwk->wstat->ptpsy - wwk->yorg;
	sts = wm_prpos (wwk, 
			(short) (wwk->wstat->ptpsx - dx), 
			(short) (wwk->wstat->ptpsy - dy));
	wm_wdraw (&ww);
    }
    else
	wm_ldraw(wwk, -1);

    return (long)res;
}

void menu_chks (struct WM_menw *menu)
{
    struct WM_pwcb *pwcb;
    short spacing;

    pwcb = menu->ypwcb;		/* part window control block (scroll) */
    spacing = -menu->ys.c._spce;

    if (menu->nrow > menu->ysize / spacing)
    {
	if (pwcb->nsec == 0)
	    menu->xsize -= WW_XBAR;	/* adjust width for bar */
	pwcb->nsec = 1;		/* one section */
	pwcb->s[0].stt = 0;	/* from zero */
	pwcb->s[0].siz = ((menu->ysize - WW_YARROW * 2) / spacing); /* size */
	menu->yoff = WW_YARROW;	/* offset for arrows */
    }
    else
    {
	if (pwcb->nsec)
	    menu->xsize += WW_XBAR;	/* adjust width for no bar */
	pwcb->nsec = 0;		/* no sections */
	menu->yoff = 0;		/* no arrows, no offset */
    }
    menu->xs.c._spce = -(menu->xsize) / menu->ncol;
    menu->xs.c._size = menu->xs.c._spce + menu->curw * 4;
}

/*******************************************************************************
*
*   Given a pointer to a menu sub-window working definition for a scrollable
*   menu this function removes the scroll bar and arrows (if present)
*
*******************************************************************************/

void menu_rems (struct WM_menw *menu)
{
    struct WM_pwcb *pwcb;

    pwcb = menu->ypwcb;		/* part window control block (scroll) */

    if (pwcb->nsec)
    {
	menu->xsize += WW_XBAR;	/* adjust width for no bar */
	pwcb->nsec = 0;		/* no sections */
	menu->yoff = 0;
    }				/* no arrows, no offset */
}


void LoadMenu (struct WM_menw *menu, LLIST *list)
{
    int i;
    struct WM_rowl *rowl;
    struct WM_mobj *mobj;
    char *mstt;
    LLIST *p;
    int nitem;

    for (p = list, nitem = 0; p; p = p->next, nitem++)
    	; /* NULL LOOP to find nitems */

    if (menu->rowl)
    {
	free (menu->rowl);
    }

    menu->rowl = NULL;
    menu->ncol = 1;
    menu->nrow = nitem;

    menu->rowl =
	rowl = (struct WM_rowl *)
	malloc((int) ((sizeof (struct WM_rowl) + sizeof (struct WM_mobj) + 1) * nitem));

    mobj = (struct WM_mobj *)
	(((char *) rowl) + sizeof (struct WM_rowl) * nitem);

    menu->mstt =
	mstt = ((char *) mobj) + sizeof (struct WM_mobj) * nitem;

    for (i = 0; i < nitem; i++)	/* initialise menu structures */
    {
	mobj->xjst = 1;
	mobj->yjst = 0;
	mobj->type = 0;
	mobj->skey = 0;
	mobj->pobj = (char *) ((MDEF *) list->item)->qtext;
	mobj->item = i;
	mobj->pact = &mact;
	rowl->rows = mobj++;	/* one object per row */
	(rowl++)->rowe = mobj;
	*(mstt++) = ((MDEF *) list->item)->status;
	list = list->next;	/* next text */
    }
}


static long lit_reset (WM_wwork_t *wwk, short lit)
{
    wwk->wstat->litem[lit] = WSI_MKAV;	/* set make available */
    return wm_ldraw (wwk, -1);	/* and re-draw */
}

static long MMOVE (struct WM_wwork *wwk,  struct WM_litm *li)
{
    short dx, dy;

    wwk->wstat->evnt |= PT_WMOVE;	/* set event bit for wm_chwin */
    wm_chwin (wwk, &dx, &dy);	/* move window */
    return lit_reset (wwk, 0);	/* and return */
}

int menu (LLIST *MList, short icount, short flag, short nx)
{
    int rval;
    short flg = 0;
    int xsize = 0, ysize = 0;
    short yinc;
    struct WM_wsiz wl;

    ww.chid = io_open("con", 0);

    if(ww.chid < 0)
    {
        return -1;
    }

    if (!(wm_findv (ww.chid)))
    {
        return -1;
    }

    iop_flim(ww.chid, -1, &wl);

    ws.wmode = FORM_QL4;
    ws.wwork = &ww;		/* cross references */
    ww.wstat = &ws;

    yinc = 12;
    ysize =  16+icount * yinc;

    if(ysize > wl.ysize)
    {
        ysize = 16 + yinc*((wl.ysize - 24)/yinc) ;
    }
    if(nx < 28) nx = 28;

    xsize = nx*6+18;
    if(xsize > wl.xsize-18)
	xsize = wl.xsize - 18;
    
    LoadMenu (&mw, MList);

    infw[0].xsize = xsize;
    ww.xsize = xsize;
    mw.xsize = xsize - 4;

    ww.ysize = ysize;
    mw.ysize = ysize-16;
    mw.xs.c._size = -mw.xsize + 4;
    mw.xs.c._spce = -mw.xsize;

    mw.ys.c._spce = -yinc;

    ws.citem = -1;		/* no current item  */

    infw[2].xorg = plitm[0].xorg = xsize - plitm[0].xsize - 6;
    infw[1].xorg = (xsize - infw[1].xsize) / 2;

    mw.curc = (flag) ? 2 : 7;
    mw.borc = 255;        
    infw[0].papr = 84;

    memcpy(PROMPT.chrs+1, ((flag) ? "Chooser" : "Viewer "), 7);

    wm_prpos (&ww, -1, -1);	/* pull down */
    wm_wdraw (&ww);

    while (!wm_rptr (&ww))
    {
	if (ws.evnt & PT_CAN)
	    break;
	if(ws.evnt & PT_WSIZE)
	{
	    menu_rems(&mw);
	    resize(&ww, 2);
            LoadMenu (&mw, MList);
	    MDRAW(&ww, &mw);
	}
    }
    return ws.litem[39];
}

static long MDRAW (WM_wwork_t *wwk, struct WM_menw *mw)
{
    menu_chks (mw);
    wm_index (wwk, (struct WM_swdef *) mw);
    wm_mdraw (wwk, (struct WM_swdef *) mw, 0);
}

static long MACT (WM_wwork_t *wwk, WM_menw_t *mw, char *mst, 
		  short col, short row)
{
    struct WM_mobj *mobj;

    mobj = mw->rowl[row].rows;	/* current menu object */
    wwk->wstat->litem[39] = mobj->item;
    return PT__CAN;
}

static long MESC (WM_wwork_t *wwk, struct WM_litm *li)
{
    wwk->wstat->litem[39] = -1;
    lit_reset (wwk, li->item);
    return PT__CAN;		/* and return CAN event */
}


#if 0
#include <stdio.h>
#include <stdarg.h>
void Report (char *ctl,...)
{
    va_list va;
    char t[80];

    va_start (va, ctl);
    vsprintf (t, ctl, va);
    va_end (va);
    io_sstrg (0x00010001, -1, t, strlen (t));
}
#endif


LLIST * BuildMenu (int *ni, int fd, short flag, short *nx)
{
    int n = -1;
    char txt[256];
    int nc;
    short ll;
    MITEM *s;
    MDEF *pm;
    LLIST *pl, *pz = 0, *ph = NULL;

    n = 0;
    while((nc = io_fline(fd, -1, txt, sizeof(txt))) > 0)
    {
	char *l;
	if((l = strchr(txt, '\n'))) *l = 0;
	nc = strlen(txt) + 4;
	s = (MITEM *) malloc (nc);
	strcpy (s->chrs, txt);
	s->len = strlen (s->chrs);
	if(s->len > *nx) *nx = s->len;
	pm = (MDEF *) malloc (sizeof (MDEF));
	pm->qtext = (struct QD_text *) s;
	pm->status = (flag) ? WSI_AVBL: WSI_UNAV;
	
	pl = (LLIST *) malloc (sizeof (LLIST));
	pl->item = pm;
	pl->next = NULL;
	if(ph == NULL) ph = pl;
	if(pz)
	{
	    pz->next = pl;
	}
	pz = pl;
	if(ll > *nx) *nx = ll;
	n++;
    }
    *ni = n;
    return ph;
}

int main(int ac, char **av)
{
    int opt;
    LLIST *RFxList = NULL;
    int RFxNum;
    int n,fd = -1;
    short nx, nc;
    char *sp;
    char flag = 0;    
    short nm;

    sp = *(av + 1);
    nc = *((short *) (sp));
    sp += sizeof(short);
    if(nc) fd = *(long *) sp;
    sp +=  nc * sizeof(long);
    nc = *((short *) (sp));

    if(fd > 0)
    {
	nm = 0;
    }
    else if(nc > 0)
    {
	char *f, fn[40];
	sp += sizeof(short);
	if(f = memchr(sp, ' ', nc))
	{
	    nm = f-sp;
	}
	else nm = nc;

	strncpy(fn, sp, nm);
	*(fn+nm) = 0;
	fd = io_open(fn, OLD_SHARE);
    }

    flag = (nm < nc); 

    if(fd > 0)
    {
	nx = 0;	
	RFxList = BuildMenu(&RFxNum, fd, flag, &nx);
	if(nc > 0) io_close(fd);
	if(RFxList)
	{
	    n = menu(RFxList, RFxNum, flag, nx);
	    if(n >= 0)
	    {
		short i;
		LLIST *p;
		for (p = RFxList, i = 0; i < n; p = p->next,i++)
		    ;
		
		{
		    MITEM *s;
		    MDEF *pm;
		    pm = (MDEF *) p->item;
		    s = (MITEM *) pm->qtext;
		    hk_stbuf(s->chrs);
		    n = 0;
		}
	    }
 	}
    }
    return n;
}
int (*_Cstart) () = main;

